unit T_SearchList;


{
                                   \\\\\/////
                                   /  _   _  \
                                  (| (.) (.) |)
 _______________________________.OOOo__( )__oOOO.______________________________
|                                                                              |
|                               This is my Tcomponent                          |
|                                    Ciao Marco                                |
|                              Email bianco@arcanet.it                         |
|                                                                              |
| DATA:      INIZIO:    FINE:      LAVORO:                                     |
|                                                                              |
| 30-08-97,  15:56:52,  17:42:51   FATTO TUTTO.                                |
|                                                                              |
|                                                                              |
|_______________________________.oooO__________________________________________|
                                (   )        Oooo.
                                 \ (         (   )
                                  \_)         ) /
                                             (_/


}
interface

uses
  FORMS,SysUtils, WinTypes, WinProcs, Classes, Graphics, Controls, StdCtrls,DIALOGS;

type
  TBiancoSearchList=class(TListBox)
  private
    { Private declarations }
    CERCA:STRING;
    CAS:BOOLEAN;//CASE SENSITIVE
    INTLEN:BOOLEAN;
    function RIC_SEARCH(const x,y:longint):longint;
    FUNCTION COMPARA(CONST S1,S2:STRING):INTEGER;
    PROCEDURE SET_CERCA(VALUE:STRING);

  protected
    { Protected declarations }
{    procedure MouseDown(MbBtn: TMouseButton; SsShift: TShiftState;
        X, Y: Integer); override;
    procedure MouseMove(SsShift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(MbBtn: TMouseButton; SsShift: TShiftState;
        X, Y: Integer); override;
}  public
    { Public declarations }
    constructor Create(AOwner:TComponent); override;
  published
    { Publish specialised properties }
    PROPERTY StringToFind:STRING READ CERCA WRITE SET_CERCA;
    PROPERTY CaseSensitivity:BOOLEAN READ CAS WRITE CAS;
    PROPERTY IntegralLength:BOOLEAN READ INTLEN WRITE INTLEN;
  //  Property ItemFound:STRING READ ITFO WRITE ITFO;
  end;

procedure Register;

implementation

//THE MAIN RECURSIVE FUNCTION, IT RETURN THE ITEM INDEX

FUNCTION TBIANCOSEARCHLIST.COMPARA(CONST S1,S2:STRING):INTEGER;
 VAR
  L1,L2,L:INTEGER;
 BEGIN
  //  <0: S1<S2
  //  =0: S1=S2
  //  >0: S1>S2
  IF INTLEN THEN
   BEGIN
    L1:=LENGTH(S1);
    L2:=LENGTH(S2);
    IF L1>L2 THEN
     L:=L2
    ELSE
     L:=L1;
    IF CAS THEN
     RESULT:=CompareStr(COPY(S1,1,L),COPY(S2,1,L))
    ELSE
     RESULT:=CompareText(COPY(S1,1,L),COPY(S2,1,L));
   END
  ELSE
   IF CAS THEN
    RESULT:=CompareStr(S1,S2)
   ELSE
    RESULT:=CompareText(S1,S2);
 END;

function TBiancoSearchList.RIC_SEARCH(const x,y:longint):longint;
// VAR
//  C:INTEGER;
 begin
  IF COMPARA(items[X],CERCA) = 0 THEN
   RESULT:=X //TROVATO
  ELSE
   IF COMPARA(items[Y],CERCA) = 0 THEN
    RESULT:=Y //TROVATO
   ELSE
    IF (X=Y) OR (X=Y-1) THEN
     RESULT:=X //NON TROVATO
    ELSE
     if COMPARA(ITEMS[(X+Y) div 2],CERCA)>0  then
      RESULT:=RIC_SEARCH(x,(x+y) div 2)
     else
      RESULT:=RIC_SEARCH((x+y) div 2,y);
 end;


PROCEDURE TBiancoSearchList.SET_CERCA(VALUE:STRING);
 BEGIN
  IF NOT SORTED THEN
   SORTED:=TRUE;
  CERCA:=VALUE;
  ITEMINDEX:=RIC_SEARCH(0,items.count-1)+1;
 END;

//**********************************************************************
procedure Register;
begin
  RegisterComponents('BIANCO', [TBiancoSearchList]);
end;

constructor TBiancoSearchList.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  RANDOMIZE;
  IF RANDOM(100)=0 THEN
   SHOWMESSAGE('TBiancoSearchList by Bianchini Marco'+#13+'EMail bianco@arcanet.it');
end;

end.
